﻿//   GDM-8000 Series Serial Sample Program for VC# 2008 or Higher
//   Please Open project (.csproj), Not Open Solution
//   ソリューションファイルでなくプロジェクトファイル(.csproj)を開いてください。

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace PSW_Access
{
    public partial class PSW_Access : Form
 
    {
        private int Opened;
        private System.Net.Sockets.TcpClient m_TcpClient;           // TCPクライアント
        private System.Net.Sockets.NetworkStream m_NetworkStream;   // ネットワークストリーム

        // Open Window
        public PSW_Access()
        {
            InitializeComponent();

            Opened = 0;

            // Set form
            btnOpen_Close.Text = "OPEN";
            btnAUTO.Enabled = false;
            btnMonitor.Enabled = false;
            btnACV.Enabled = false;
            btnDCV.Enabled = false;
            btnDCI.Enabled = false;
            btnFREQ.Enabled = false;
            txtIPAddress.Enabled = true;
        }

        // Form Close(x Button)
        private void Form1_FormClosing(object sender,FormClosingEventArgs e)
        {
            // Device Close
            if (txtIPAddress.Enabled == false)
            {
                WriteLine("CONF:AUTO OFF\n");
                System.Threading.Thread.Sleep(200);
            }
            if (Opened != 0)
            {
                if (this.m_TcpClient != null && this.m_TcpClient.Connected == true)
                {
                    this.m_NetworkStream.Close();
                    this.m_TcpClient.Close();
                }
                this.m_NetworkStream = null;
                this.m_TcpClient = null;
            }
        }

        // Open/Close Button
        private void btnOpen_Close_Click(object sender, EventArgs e)
        {
            string RdMsg;
            if(btnOpen_Close.Text == "OPEN"){
                try
                {
                    Opened = 1;
                    Cursor.Current = Cursors.WaitCursor;

                    // Device Open and Init
                    this.m_TcpClient = new System.Net.Sockets.TcpClient();
                    this.m_TcpClient.Connect(txtIPAddress.Text, int.Parse(txtIPPort.Text) );
                    this.m_NetworkStream = this.m_TcpClient.GetStream();

                    WriteLine("CONF:AUTO OFF\n");
                    btnAUTO.Text = "AUTO ON";
                    RdMsg = Readbuff();

                    // Set form
                    btnOpen_Close.Text = "CLOSE";
                    btnAUTO.Enabled = true;
                    btnMonitor.Enabled = true;
                    btnACV.Enabled = true;
                    btnDCV.Enabled = true;
                    btnDCI.Enabled = true;
                    btnFREQ.Enabled = true;
                    txtIPAddress.Enabled = false;

                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                    this.m_NetworkStream = null;
                    this.m_TcpClient = null;
                }
                finally
                {
                    Cursor.Current = Cursors.Default;
                }
            }
            else{
                try
                {
                    // Device Close
                    WriteLine("CONF:AUTO OFF\n");
                    WriteLine("SYST:LOC\n");
                    System.Threading.Thread.Sleep(200);
                    if (this.m_TcpClient != null && this.m_TcpClient.Connected == true)
                    {
                        this.m_NetworkStream.Close();
                        this.m_TcpClient.Close();
                    }
                    this.m_NetworkStream = null;
                    this.m_TcpClient = null;

                    // Set form
                    btnOpen_Close.Text = "OPEN";
                    btnAUTO.Enabled = false ;
                    btnMonitor.Enabled = false ;
                    btnACV.Enabled = false;
                    btnDCV.Enabled = false;
                    btnDCI.Enabled = false;
                    btnFREQ.Enabled = false;
                    txtIPAddress.Enabled = true;
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }

        }
        

        // Monitor Button
        private void btnMonitor_Click(object sender, EventArgs e)
        {
            try
            {
                Cursor.Current = Cursors.WaitCursor;
                WriteLine("READ?\n");
                System.Threading.Thread.Sleep(500);
                txtMeasure.Text = Readbuff() + " \r\n";
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            finally
            {
                Cursor.Current = Cursors.Default;
            }
        }


        private void btnAUTO_Click(object sender, EventArgs e)
        {
            if (btnAUTO.Text == "AUTO ON")
            {
                // OFF -> ON
                WriteLine("CONF:AUTO ON\n");
                btnAUTO.Text = "AUTO OFF";
            }
            else
            {
                // ON -> OFF
                WriteLine("CONF:AUTO OFF\n");
                btnAUTO.Text = "AUTO ON";
            }
        }

        private void btnDCV_Click(object sender, EventArgs e)
        {
            string SendMsg;

            SendMsg = "CONF:VOLT:DC\n";
            try
            {
                WriteLine(SendMsg);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void btnACV_Click(object sender, EventArgs e)
        {
            string SendMsg;

            SendMsg = "CONF:VOLT:AC\n";
            try
            {
                WriteLine(SendMsg);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void btnDCI_Click(object sender, EventArgs e)
        {
            string SendMsg;

            SendMsg = "CONF:CURR:DC\n";
            try
            {
                WriteLine(SendMsg);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void btnFREQ_Click(object sender, EventArgs e)
        {
            string SendMsg;

            SendMsg = "CONF:FREQ\n";
            try
            {
                WriteLine(SendMsg);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void WriteLine(string sendMsg)
        {
            byte[] SendBuff = System.Text.Encoding.GetEncoding("SHIFT-JIS").GetBytes(sendMsg);
            m_NetworkStream.Write(SendBuff, 0, SendBuff.Length);
            m_NetworkStream.Flush();
        }

        private string Readbuff()
        {
            byte[] reciveBufff = new byte[256];

            int DataCnt = this.m_TcpClient.Available;
            if (DataCnt > 255) DataCnt = 255;
            m_NetworkStream.Read(reciveBufff, 0, DataCnt);
            return System.Text.Encoding.GetEncoding("SHIFT-JIS").GetString(reciveBufff).Substring(0, DataCnt);
        }

        private string ReplaceCommonEscapeSequences(string s)
        {
            return s.Replace("\\n", "\n").Replace("\\r", "\r");
        }

        private string InsertCommonEscapeSequences(string s)
        {
            return s.Replace("\n", "\\n").Replace("\r", "\\r").Replace("\0", "\\0");
        }
    }
}
